ConfigurationPermission
Date: 2016-06-25

org.osgi.service.cm

## Class ConfigurationPermission

- java.lang.Object
- - java.security.Permission
  - - java.security.BasicPermission
    - - org.osgi.service.cm.ConfigurationPermission

- All Implemented Interfaces:
    java.io.Serializable, java.security.Guard

      public final class ConfigurationPermission
      extends java.security.BasicPermission

  Indicates a bundle's authority to configure bundles or be updated by Configuration Admin.
  Since:
    1.2
  See Also:
    Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static java.lang.String` | `CONFIGURE` Provides permission to create new configurations for other bundles as well as manipulate them.
    `static java.lang.String` | `TARGET` The permission to be updated, that is, act as a Managed Service or Managed Service Factory.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ConfigurationPermission(java.lang.String name, java.lang.String actions)` Create a new ConfigurationPermission.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `equals(java.lang.Object obj)` Determines the equality of two `ConfigurationPermission` objects.
    `java.lang.String` | `getActions()` Returns the canonical string representation of the `ConfigurationPermission` actions.
    `int` | `hashCode()` Returns the hash code value for this object.
    `boolean` | `implies(java.security.Permission p)` Determines if a `ConfigurationPermission` object "implies" the specified permission.
    `java.security.PermissionCollection` | `newPermissionCollection()` Returns a new `PermissionCollection` object suitable for storing `ConfigurationPermission`s.

    - ### Methods inherited from class java.security.Permission

      `checkGuard, getName, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### CONFIGURE

          public static final java.lang.String CONFIGURE

      Provides permission to create new configurations for other bundles as well as manipulate them. The action string "configure".
      See Also:
        Constant Field Values

    - #### TARGET

          public static final java.lang.String TARGET

      The permission to be updated, that is, act as a Managed Service or Managed Service Factory. The action string "target".
      Since:
        1.4
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### ConfigurationPermission

          public ConfigurationPermission(java.lang.String name,
                                 java.lang.String actions)

      Create a new ConfigurationPermission.
      Parameters:
        `name` - Name of the permission. Wildcards (`'*'`) are allowed in the name. During `implies(Permission)`, the name is matched to the requested permission using the substring matching rules used by `Filter`s.
        `actions` - Comma separated list of `CONFIGURE`, `TARGET` (case insensitive).

  - ### Method Detail

    - #### implies

          public boolean implies(java.security.Permission p)

      Determines if a `ConfigurationPermission` object "implies" the specified permission.
      Overrides:
        `implies` in class `java.security.BasicPermission`
      Parameters:
        `p` - The target permission to check.
      Returns:
        `true` if the specified permission is implied by this object; `false` otherwise.

    - #### equals

          public boolean equals(java.lang.Object obj)

      Determines the equality of two `ConfigurationPermission` objects.

      Two `ConfigurationPermission` objects are equal.

      Overrides:
        `equals` in class `java.security.BasicPermission`
      Parameters:
        `obj` - The object being compared for equality with this object.
      Returns:
        `true` if `obj` is equivalent to this `ConfigurationPermission`; `false` otherwise.

    - #### hashCode

          public int hashCode()

      Returns the hash code value for this object.
      Overrides:
        `hashCode` in class `java.security.BasicPermission`
      Returns:
        Hash code value for this object.

    - #### getActions

          public java.lang.String getActions()

      Returns the canonical string representation of the `ConfigurationPermission` actions.

      Always returns present `ConfigurationPermission` actions in the following order: "configure", "target"

      Overrides:
        `getActions` in class `java.security.BasicPermission`
      Returns:
        Canonical string representation of the `ConfigurationPermission` actions.

    - #### newPermissionCollection

          public java.security.PermissionCollection newPermissionCollection()

      Returns a new `PermissionCollection` object suitable for storing `ConfigurationPermission`s.
      Overrides:
        `newPermissionCollection` in class `java.security.BasicPermission`
      Returns:
        A new `PermissionCollection` object.